-- Classic Trojan HUD version 1.0
-- scripting by Hopper (edit by President People)
-- images and layout copyright Bungie and "copyright" Trojan Team

-- player/team colors, for net name and stats panel
colortable = { def    = { 0.00, 1.00, 0.00, 1.0 },
               slate  = { 0.14, 0.37, 0.64, 1.0 },
               red    = { 1.00, 0.00, 0.00, 1.0 },
               violet = { 0.69, 0.00, 0.37, 1.0 },
               yellow = { 1.00, 1.00, 0.00, 1.0 },
               white  = { 0.92, 0.92, 0.92, 1.0 },
               orange = { 0.96, 0.34, 0.00, 1.0 },
               blue   = { 0.05, 0.00, 1.00, 1.0 },
               green  = { 0.00, 1.00, 0.00, 1.0 } }

-- from Marathon's resource fork
nrct = {
  { left=  0, top=  0, right=640, bottom= 23 },  --  1. (top of hud)
  { left=  0, top= 23, right=176, bottom=295 },  --  2. (left of game)
  { left=624, top= 23, right=640, bottom=297 },  --  3. (right of game)
  { left=  0, top=295, right=215, bottom=480 },  --  4. (bottom left)
  { left= 20, top= 26, right=113, bottom=119 },  --  5. (hey look, it's the compass!)
  { left= 77, top=274, right=163, bottom=286 },  --  6. network name
  { left= 88, top=147, right=104, bottom=259 },  --  7. oxygen
  { left=136, top=147, right=152, bottom=259 },  --  8. health
  { left= 29, top=314, right=152, bottom=437 },  --  9. radar
  { left=163, top=390, right=203, bottom=440 },  -- 10. b10 / b12 mic
  { left=172, top=398, right=193, bottom=417 },  -- 11. (small area near mic -- unused alt?)
  { left=564, top=  0, right=621, bottom= 23 },  -- 12. b7 / b8 light
  { left=217, top=366, right=398, bottom=454 },  -- 13. inventory
  { left=398, top=366, right=620, bottom=454 },  -- 14. weapons
  { left=235, top=305, right=293, bottom=349 },  -- 15. (in nameplate - lost feature?)
  { left=313, top=305, right=380, bottom=349 },  -- 16. (in nameplate - lost feature?)
  { left=396, top=305, right=450, bottom=349 },  -- 17. (in nameplate - lost feature?)
  { left=475, top=305, right=526, bottom=349 },  -- 18. (in nameplate - lost feature?)
  { left=549, top=305, right=598, bottom=349 },  -- 19. (in nameplate - lost feature?)
  { left=180, top= 26, right=619, bottom= 40 },  -- 20. (in game area)
  { left=180, top=277, right=619, bottom=291 },  -- 21. (in game area)
  { left=176, top= 23, right=624, bottom=295 },  -- 22. game area
  { left=180, top= 45, right=619, bottom=272 },  -- 23. (in game area)
  { left=180, top= 45, right=403, bottom=272 },  -- 24. (in game area)
  { left=406, top= 45, right=619, bottom=272 },  -- 25. (in game area)
  { left=180, top= 94, right=619, bottom=178 },  -- 26. (in game area)
  { left=180, top=190, right=619, bottom=178 },  -- 27. (in game area)
  { left=180, top=207, right=619, bottom=225 },  -- 28. (in game area)
  { left= 88, top=290, right=152, bottom=293 },  -- 29. b11 / b13 bar
  { left=251, top=146, right=388, bottom=176 },  -- 30. Begin New Game
  { left=251, top=180, right=388, bottom=210 },  -- 31. Continue Saved Game
  { left=118, top=212, right=236, bottom=236 },  -- 32. Gather Network Game
  { left=123, top=244, right=231, bottom=268 },  -- 33. Join Network Game
  { left=143, top=278, right=210, bottom=303 },  -- 34. Preferences
  { left=416, top=215, right=507, bottom=240 },  -- 35. Replay Last Film
  { left=423, top=248, right=502, bottom=272 },  -- 36. Save Last Film
  { left=412, top=279, right=511, bottom=304 },  -- 37. Replay Saved Film
  { left=297, top=362, right=344, bottom=391 },  -- 38. Credits
  { left=297, top=395, right=343, bottom=423 },  -- 39. Quit
  { left=265, top=222, right=372, bottom=296 },  -- 40. center area on main screen
  { left=215, top=295, right=621, bottom=363 },  -- 41. (above inventory)
  { left=215, top=458, right=621, bottom=480 },  -- 42. (underneath inventory)
  { left=621, top=295, right=640, bottom=480 },  -- 43. (bottom right)
}

-- These definitions are in M2/Infinity form, roughly, but use
-- Marathon's positions found by screen capture comparison.
wdef = {}
wdef["fist"] = { start_y=440, end_y=439, start_x=-1, end_x=-1, top=0, left=0 }
wdef["pistol"] = { start_y=439, end_y=451, start_x=440, end_x=-1, top=373, left=528, mult_delta_x=-97, mult_delta_y=0 }
wdef["pistol"].primary = { display="ammo", left=535, top=415, across=8, down=1, delta_x=5, delta_y=14, rtl=true }
wdef["pistol"].secondary = { display="ammo", left=469, top=415, across=8, down=1, delta_x=5, delta_y=14 }
wdef["fusion pistol"] = { start_y=438, end_y=450, start_x=421, end_x=-1, top=373, left=459 }
wdef["fusion pistol"].primary = { display="energy", left=552, top=375, width=19, height=57 }
wdef["assault rifle"] = { start_y=428, end_y=457, start_x=462, end_x=-1, top=373, left=480 }
wdef["assault rifle"].primary = { display="ammo", left=411, top=375, across=13, down=4, delta_x=4, delta_y=12 }
wdef["assault rifle"].secondary = { display="ammo", left=410, top=432, across=7, down=1, delta_x=8, delta_y=14 }
wdef["missile launcher"] = { start_y=440, end_y=452, start_x=446, end_x=-1, top=372, left=479 }
wdef["missile launcher"].primary = { display="ammo", left=445, top=376, across=2, down=1, delta_x=15, delta_y=56 }
wdef["flamethrower"] = { start_y=440, end_y=452, start_x=418, end_x=-1, top=370, left=508 }
wdef["flamethrower"].primary = { display="energy", left=461, top=375, width=38, height=57 }
wdef["alien weapon"] = { start_y=425, end_y=452, start_x=422, end_x=588, top=366, left=400 }
wdef["ball"] = { start_y=439, end_y=451, start_x=416, end_x=-1, top=373, left=482 }

Triggers = {}
function Triggers.init()
  
  -- align weapon and item mnemonics
  ItemTypes["knife"].mnemonic = "fist"

  opengl = true
  if Screen.renderer == "software" then
    opengl = false
  end
  
  img = {}
  img.bgTop      = Images.new{path = "resources/images/i128.png"}  
  img.bgLeft     = Images.new{path = "resources/images/i128.png"}  
  img.bgRight    = Images.new{path = "resources/images/i128.png"}  
  img.bgBottom   = Images.new{path = "resources/images/i128.png"}  
  img.bgRadar    = Images.new{path = "resources/images/b21.png"}
  img.fgRadar    = Images.new{path = "resources/images/b21_overlay.png"}
  
  img.barHealth1 = Images.new{path = "resources/images/b3.png"}
  img.capHealth1 = Images.new{path = "resources/images/b5.png"}
  img.barHealth2 = Images.new{path = "resources/images/b54.png"}
  img.capHealth2 = Images.new{path = "resources/images/b56.png"}
  img.barHealth3 = Images.new{path = "resources/images/b55.png"}
  img.capHealth3 = Images.new{path = "resources/images/b57.png"}
  img.barOxygen  = Images.new{path = "resources/images/b4.png"}
  img.capOxygen  = Images.new{path = "resources/images/b6.png"}
  
  img.microphone = Images.new{path = "resources/images/b12.png"}
  img.blinkerOn  = Images.new{path = "resources/images/b8.png"}
  img.blinkerOff = Images.new{path = "resources/images/b7.png"}
  img.respawnbar = Images.new{path = "resources/images/b13.png"}
  
  img.friend = {
    Images.new{path = "resources/images/b29.png"},
    Images.new{path = "resources/images/b30.png"},
    Images.new{path = "resources/images/b31.png"},
    Images.new{path = "resources/images/b32.png"},
    Images.new{path = "resources/images/b33.png"},
    Images.new{path = "resources/images/b34.png"} }

  img.alien = {
    Images.new{path = "resources/images/b23.png"},
    Images.new{path = "resources/images/b24.png"},
    Images.new{path = "resources/images/b25.png"},
    Images.new{path = "resources/images/b26.png"},
    Images.new{path = "resources/images/b27.png"},
    Images.new{path = "resources/images/b28.png"} }
  
  img["hostile player"] = {
    Images.new{path = "resources/images/b46.png"},
    Images.new{path = "resources/images/b47.png"},
    Images.new{path = "resources/images/b48.png"},
    Images.new{path = "resources/images/b49.png"},
    Images.new{path = "resources/images/b50.png"},
    Images.new{path = "resources/images/b51.png"} }
  
  img.weapons = {}
  img.weapons["pistol left dis"] = Images.new{path = "resources/images/b9.png"}
  img.weapons["pistol"] = Images.new{path = "resources/images/b14.png"}
  img.weapons["pistol left"] = Images.new{path = "resources/images/b15.png"}
  img.weapons["fusion pistol"] = Images.new{path = "resources/images/b16.png"}
  img.weapons["assault rifle"] = Images.new{path = "resources/images/b17.png"}
  img.weapons["missile launcher"] = Images.new{path = "resources/images/b18.png"}
  img.weapons["alien weapon"] = Images.new{path = "resources/images/b43.png"}
  img.weapons["flamethrower"] = Images.new{path = "resources/images/b45.png"}
  img.weapons["ball"] = Images.new{path = "resources/images/skull.png"}
  
  img.ammo = {}
  img.ammo["assault rifle 2 full"] = Images.new{path = "resources/images/b35.png"}
  img.ammo["assault rifle 2 empty"] = Images.new{path = "resources/images/b36.png"}
  img.ammo["missile launcher 1 full"] = Images.new{path = "resources/images/b37.png"}
  img.ammo["missile launcher 1 empty"] = Images.new{path = "resources/images/b38.png"}
  img.ammo["pistol 1 full"] = Images.new{path = "resources/images/b39.png"}
  img.ammo["pistol 1 empty"] = Images.new{path = "resources/images/b40.png"}
  img.ammo["pistol 2 full"] = Images.new{path = "resources/images/b39.png"}
  img.ammo["pistol 2 empty"] = Images.new{path = "resources/images/b40.png"}
  img.ammo["assault rifle 1 full"] = Images.new{path = "resources/images/b41.png"}
  img.ammo["assault rifle 1 empty"] = Images.new{path = "resources/images/b42.png"}
  

  rawpos = {}
  rawpos.gameRect = getRect(22)
  rawpos.bgTop    = { x = 0, y = 0,
                      w = 640, h = rawpos.gameRect.y }
  rawpos.bgLeft   = { x = 0, y = rawpos.gameRect.y,
                      w = rawpos.gameRect.x, h = rawpos.gameRect.h }
  rawpos.bgRight  = { x = rawpos.gameRect.x + rawpos.gameRect.w,
                      y = rawpos.gameRect.y,
                      w = 640 - (rawpos.gameRect.x + rawpos.gameRect.w),
                      h = rawpos.gameRect.h }
  rawpos.bgBottom = { x = 0, y = rawpos.gameRect.y + rawpos.gameRect.h,
                      w = 640,
                      h = 480 - (rawpos.gameRect.y + rawpos.gameRect.h) }
  rawpos.bgRadar  = getRect(9)
  
  rawpos.blinker    = getRect(12)
  rawpos.microphone = getRect(10)
  rawpos.respawnbar = getRect(29)
  rawpos.net_name   = getRect(6)
  rawpos.oxygen     = getRect(7)
  rawpos.health     = getRect(8)
  
  rawpos.inv_panel  = getRect(13)
  rawpos.wep_panel  = getRect(14)
  
  Triggers.resize()
end

function getRect(idx)
  return { x = nrct[idx].left, y = nrct[idx].top,
           w = nrct[idx].right - nrct[idx].left,
           h = nrct[idx].bottom - nrct[idx].top }
end

function adj(number)
  return math.floor(number)
end

function scaled(number)
  return adj(number * scale)
end

function Triggers.resize()

  local ar = 640. / 480.
  sh = adj(math.min(Screen.height, Screen.width / ar))
  sw = adj(math.min(Screen.width, sh * ar))
  sx = adj((Screen.width - sw)/2.)
  sy = adj((Screen.height - sh)/2.)
  scale = sw / 640.
  
  for k in pairs(img) do
    if type(img[k]) == "table" then
      for kk in pairs(img[k]) do
        img[k][kk]:rescale(scaled(img[k][kk].unscaled_width), scaled(img[k][kk].unscaled_height))
      end
    else
      img[k]:rescale(scaled(img[k].unscaled_width), scaled(img[k].unscaled_height))
    end
  end

  pos = {}
  for k in pairs(rawpos) do
    local p = rawpos[k]
    if type(p) == "table" then
      pos[k] = { }
      for kk in pairs(p) do
        pos[k][kk] = scaled(p[kk])
      end
    else
      pos[k] = scaled(p)
    end
  end
  pos.weapon_text = {}
  pos.weapon_sprites = {}
  pos.weapon_ammo = {}
  for k in pairs(wdef) do
    local w = wdef[k]
    local left = w.start_x
    if left < 0 then left = rawpos.wep_panel.x end
    local right = w.end_x
    if right < 0 then right = rawpos.wep_panel.x + rawpos.wep_panel.w end
    local top = w.start_y
    if top < 0 then top = rawpos.wep_panel.y end
    pos.weapon_text[k] = { x = sx + scaled(left), y = sy + scaled(top), w = scaled(right - left) }
    if img.weapons[k] then
      pos.weapon_sprites[k] = { x = sx + scaled(w.left), y = sy + scaled(w.top) }
      if img.weapons[k .. " left"] then
        pos.weapon_sprites[k .. " left"] = { x = pos.weapon_sprites[k].x + scaled(w.mult_delta_x), y = pos.weapon_sprites[k].y + scaled(w.mult_delta_y) }
      end
    end
    
    for i, v in ipairs({ w.primary, w.secondary }) do
      if not v then return end
      if v.display == "ammo" then
        pos.weapon_ammo[k .. " ammo " .. i] = { x = sx + scaled(v.left), y = sy + scaled(v.top), bullets = v.across, rows = v.down, w = (v.delta_x * scale), h = scaled(v.delta_y), rtl = v.rtl }
      elseif v.display == "energy" then
        pos.weapon_ammo[k .. " energy " .. i] = { x = sx + scaled(v.left), y = sy + scaled(v.top), w = scaled(v.width), h = scaled(v.height) }
      end
    end
  end
  
  img.bgTop.crop_rect.x = pos.bgTop.x
  img.bgTop.crop_rect.y = pos.bgTop.y
  img.bgTop.crop_rect.width = pos.bgTop.w
  img.bgTop.crop_rect.height = pos.bgTop.h
  img.bgLeft.crop_rect.x = pos.bgLeft.x
  img.bgLeft.crop_rect.y = pos.bgLeft.y
  img.bgLeft.crop_rect.width = pos.bgLeft.w
  img.bgLeft.crop_rect.height = pos.bgLeft.h
  img.bgRight.crop_rect.x = pos.bgRight.x
  img.bgRight.crop_rect.y = pos.bgRight.y
  img.bgRight.crop_rect.width = pos.bgRight.w
  img.bgRight.crop_rect.height = pos.bgRight.h
  img.bgBottom.crop_rect.x = pos.bgBottom.x
  img.bgBottom.crop_rect.y = pos.bgBottom.y
  img.bgBottom.crop_rect.width = pos.bgBottom.w
  img.bgBottom.crop_rect.height = pos.bgBottom.h
  
  Screen.world_rect.width = pos.gameRect.w
  Screen.world_rect.x = pos.gameRect.x + sx
  Screen.world_rect.height = pos.gameRect.h
  Screen.world_rect.y = pos.gameRect.y + sy
  
  Screen.map_rect.x = Screen.world_rect.x
  Screen.map_rect.y = Screen.world_rect.y
  Screen.map_rect.width = Screen.world_rect.width
  Screen.map_rect.height = Screen.world_rect.height
  
  Screen.term_rect.width = math.max(640, Screen.world_rect.width)
  Screen.term_rect.height = math.max(320, Screen.world_rect.height)
  Screen.term_rect.x = math.max(sx, math.min(Screen.world_rect.x, sx + sw - 640))
  Screen.term_rect.y = math.max(sy, math.min(Screen.world_rect.y, Screen.world_rect.y + Screen.world_rect.height - 320))
  
  if scaled(9) < 10.5 then
    bgf = Fonts.new{id = 4, size = 9, style = 1}
  else
    bgf = Fonts.new{file = "resources/ProFontWinTweaked/ProFontWindows.ttf", size = scaled(12), style = 1}
  end
  if scaled(9) < 10.5 then
    bgfn = Fonts.new{id = 4, size = 9, style = 0}
  else
    bgfn = Fonts.new{file = "resources/ProFontWinTweaked/ProFontWindows.ttf", size = scaled(12), style = 0}
  end
  bgfLineHeight = scaled(11)
  
end


function Triggers.draw()
  unclip()
  
  -- background
  for i,v in pairs({ img.bgTop, img.bgLeft, img.bgRight, img.bgBottom }) do
    v:draw(sx + v.crop_rect.x, sy + v.crop_rect.y)
  end
  
  -- in Marathon, light turns green when you're ready to respawn in net games;
  -- we don't have that information, so just turn it green on death
  if Player.dead then
    img.respawnbar:draw(sx + pos.respawnbar.x, sy + pos.respawnbar.y)
  end
  
  drawNetName(pos.net_name)
  
  -- blinky light
  if (Game.ticks % 60) < 30 then
    img.blinkerOn:draw(sx + pos.blinker.x, sy + pos.blinker.y)
  else
    img.blinkerOff:draw(sx + pos.blinker.x, sy + pos.blinker.y)
  end
  
  if Player.microphone_active then
    img.microphone:draw(sx + pos.microphone.x, sy + pos.microphone.y)
  end
  
  drawRadar(pos.bgRadar)  

  -- oxygen bar
  drawBar(img.barOxygen, img.capOxygen, pos.oxygen, Player.oxygen, 10800)
  
  -- health bar
  drawBar(img.barHealth1, img.capHealth1, pos.health, Player.life, 150)
  drawBar(img.barHealth2, img.capHealth2, pos.health, Player.life - 150, 150)
  drawBar(img.barHealth3, img.capHealth3, pos.health, Player.life - 300, 150)

  -- inventory
  drawInventory(pos.inv_panel)
  
  -- weapons
  if Player.weapons.desired then
    local weapon = Player.weapons.desired
    
    if weapon then
      clip(pos.wep_panel)
      
      drawWeapon(weapon)
      draw_text_center(bgf, bgfLineHeight, weapon.name, pos.weapon_text[weapon.type.mnemonic], { 0, 1, 0, 1 })
      
      unclip()
    end      
  end
  
end

function drawRadar(rect)
  if not Player.motion_sensor.active then return end
  clip(rect)
    
  img.bgRadar:draw(sx + rect.x, sy + rect.y)

  local sens_rad = adj(rect.w / 2)
  local sens_xcen = sx + rect.x + sens_rad
  local sens_ycen = sy + rect.y + sens_rad
  
  -- compass
  local compass_clr = { 1, 0, 0, 0.2 }
  if Player.compass.nw then
    Screen.fill_rect(rect.x, rect.y, sens_rad, sens_rad, compass_clr)
  end
  if Player.compass.ne then
    Screen.fill_rect(sens_xcen, rect.y, sens_rad, sens_rad, compass_clr)
  end
  if Player.compass.sw then
    Screen.fill_rect(rect.x, sens_ycen, sens_rad, sens_rad, compass_clr)
  end
  if Player.compass.se then
    Screen.fill_rect(sens_xcen, sens_ycen, sens_rad, sens_rad, compass_clr)
  end
  
  -- blips
  for i = 1,#Player.motion_sensor.blips do
    local blip = Player.motion_sensor.blips[i - 1]
    local mult = blip.distance * sens_rad / 8
    local rad = math.rad(blip.direction)
    local xoff = sens_xcen + math.cos(rad) * mult
    local yoff = sens_ycen + math.sin(rad) * mult
    
    local image = img[blip.type.mnemonic][blip.intensity + 1]
    image:draw(xoff - adj(image.width / 2), yoff - adj(image.height / 2))
  end
  
  -- overlay, to clean up edges
  img.fgRadar:draw(sx + rect.x, sy + rect.y)
  unclip()
end

function drawNetName(rect)
  if #Game.players <= 1 then return end
  
  -- find current player, for color
  local p = nil
  for i = 1,#Game.players do
    if Game.players[i-1].active then
      p = Game.players[i-1]
      break
    end
  end
  if not p then return end
  
  local tw, th = bgfn:measure_text(p.name)
  clip(rect)
  bgfn:draw_text(p.name, sx + rect.x + adj((rect.w - tw)/2), sy + rect.y, colortable[p.color.mnemonic])
  unclip()
end

-- from Lua-users wiki
function explode(d,p)
  local t, ll
  t={}
  ll=0
  if(#p == 1) then return {p} end
    while true do
      l=string.find(p,d,ll,true) -- find the next d in the string
      if l~=nil then -- if "not not" found then..
        table.insert(t, string.sub(p,ll,l-1)) -- Save it in our array.
        ll=l+1 -- save just after where we found it for searching next time.
      else
        table.insert(t, string.sub(p,ll)) -- Save what's left in our array.
        break -- Break at end, as it should be, according to the lua manual.
      end
    end
  return t
end

function draw_text_center(font, line_height, text, rect, color)
  if not text then return end
  if not rect then return end
  
  local tw, th = font:measure_text(text)
  if tw <= rect.w then
    font:draw_text(text, rect.x + adj((rect.w - tw)/2), rect.y, color)
    return
  end
  
  local y = rect.y
  local parts = explode(" ", text)
  while #parts > 0 do
    local line = table.remove(parts, 1)
    if #parts > 0 then
      local nextwd = table.remove(parts, 1)
      local nw, nh = font:measure_text(line .. " " .. nextwd)
      while nw < rect.w do
        line = line .. " " .. nextwd
        nextwd = nil
        if #parts < 1 then break end
        nextwd = table.remove(parts, 1)
        nw, nh = font:measure_text(line .. " " .. nextwd)
      end
      if nextwd ~= nil then table.insert(parts, 1, nextwd) end
    end
    
    tw, th = font:measure_text(line)
    font:draw_text(line, rect.x + adj((rect.w - tw)/2), y, color)
    y = y + line_height
  end
end

function drawInventory(rect)
  clip(rect)
  
  local off = scaled(2)
  local x = sx + rect.x
  local y = sy + rect.y
  local w = rect.w
  local h = bgfLineHeight
  local lasty = y + (8 * h)
  local clr = { 0, 1, 0, 1 }
  local sec = Player.inventory_sections.current
  
  -- header
  Screen.fill_rect(x, y, w, h, { 0, 0.2, 0, 1 })
  local extra = nil
  if sec.type == "network statistics" then
    draw_text_right(bgf, net_header(), x + w - off, y, clr)
  end
  bgf:draw_text(sec.name, x + off, y, clr)
  y = y + h
  
  local ctx = bgfn:measure_text("999")
  ctx = ctx + x + off
  local inx = bgf:measure_text("999")
  inx = inx + x + off + off
  
  if sec.type == "network statistics" then
    -- player list and rankings
    local all_players = sorted_players()
    local gametype = Game.type
    if gametype == "netscript" then
      gametype = Game.scoring_mode
    end

    inx = x + off
    ctx = x + w - off

    for i = 1,#all_players do
      local p = all_players[i]
      local score = ranking_text(gametype, p.ranking)
      draw_text_right(bgf, score, ctx, y, colortable[p.team.mnemonic])
      bgf:draw_text(p.name, inx, y, colortable[p.color.mnemonic])
      
      y = y + h
      if y >= lasty then break end
    end
  else
    for i = 1,#ItemTypes do
      local item = Player.items[i - 1]
      local name = ItemTypes[i - 1]
      if (item.count > 0 and item.inventory_section == sec.type) and not (name == "fist") then
        local ct = string.format("%d", item.count)
        draw_text_right(bgfn, ct, ctx, y, clr)
        
        local iname
        if item.count == 1 then
          iname = item.singular
        else
          iname = item.plural
        end
        
        -- use short names, not M1A1 changed ones
        if iname == "ZEUS-CLASS FUSION PISTOL" then
          iname = "ZEUS-CLASS FUSION PSTL"
        elseif iname == "MA-75 ASSAULT RIFLE/GRENADE LAUNCHER" then
          iname = "MA-75 ASSAULT RIFLE"
        elseif iname == "TOZT-7 BACKPACK NAPALM UNIT" then
          iname = "TOZT-7 NAPALM UNIT"
        end
        
        bgf:draw_text(string.sub(iname, 1, 22), inx, y, clr)
        
        y = y + h
        if y >= lasty then break end
      end
    end
  end
  
  unclip(rect)
end

function draw_text_right(font, text, x, y, color)
  if text == nil then return end
  local tx, ty = font:measure_text(text)
  font:draw_text(text, x - tx, y, color)
end

function clip(rect)
  Screen.clip_rect.x = sx + rect.x
  Screen.clip_rect.y = sy + rect.y
  Screen.clip_rect.width = rect.w
  Screen.clip_rect.height = rect.h
end

function unclip()
  clip({ x = 0, y = 0, w = sw, h = sh })
end

function drawBar(bar, cap, rect, cur, max)
  if cur <= 0 then return end
  if cur == max then
    bar.crop_rect.y = 0
    bar.crop_rect.height = bar.height
    bar:draw(sx + rect.x, sy + rect.y)
  end
  
  local bottom = sy + rect.y + rect.h
  local total_h = adj(rect.h * math.max(0, math.min(cur, max)) / max)
  local cap_h = adj(math.min(cap.height, total_h / 2))
  local bar_h = total_h - cap_h
  
  bar.crop_rect.height = bar_h
  bar.crop_rect.y = bar.height - bar_h
  bar:draw(sx + rect.x, bottom - bar_h)
  
  cap.crop_rect.height = cap_h
  cap:draw(sx + rect.x, bottom - total_h)
end    
  
function drawWeapon(weapon)
  local wt = weapon.type.mnemonic
  local image = img.weapons[wt]
  if not image then return end
  
  local wp = pos.weapon_sprites[wt]
  image:draw(wp.x, wp.y)
  
  drawAmmo(pos.weapon_ammo[wt .. " ammo 1"], weapon.primary.rounds, img.ammo[wt .. " 1 full"], img.ammo[wt .. " 1 empty"])
  drawEnergy(pos.weapon_ammo[wt .. " energy 1"], weapon.primary.rounds / weapon.primary.total_rounds)
  
  wp = pos.weapon_sprites[wt .. " left"]
  if wp then
    if Player.items[wt].count > 1 then
      image = img.weapons[wt .. " left"]
    else
      image = img.weapons[wt .. " left dis"]
    end
    if image then
      image:draw(wp.x, wp.y)
    end
  end
  
  drawAmmo(pos.weapon_ammo[wt .. " ammo 2"], weapon.secondary.rounds, img.ammo[wt .. " 2 full"], img.ammo[wt .. " 2 empty"])
end

function drawAmmo(info, rounds, image_full, image_empty)
  if not info then return end
  if not image_full then return end
  if not image_empty then return end
  
  local x = info.x
  local y = info.y
  local drawn = 0
  for r = 1,info.rows do
    image_empty:draw(x, y)
    if rounds > drawn then
      local to_draw = math.min(rounds - drawn, info.bullets)
      local draw_w = adj(info.w * to_draw)
      local draw_x = x
      image_full.crop_rect.width = draw_w
      if info.rtl then
        local offx = adj(info.w * (info.bullets - to_draw))
        image_full.crop_rect.x = offx
        draw_x = x + offx
      end
      image_full:draw(draw_x, y)
      drawn = drawn + to_draw
    end
    y = y + info.h
  end
end

function drawEnergy(info, frac)
  if not info then return end
  
  Screen.fill_rect(info.x, info.y, info.w, info.h, { 0, 1, 0, 1 })
  if frac >= 1.0 then return end
  
  local m = scaled(1)
  Screen.fill_rect(info.x + m, info.y + m, info.w - (2 * m), adj((1.0 - frac) * (info.h - (2 * m))), { 0, 0, 0, 1 })
end

function format_time(ticks)
   local secs = math.ceil(ticks / 30)
   return string.format("%d:%02d", math.floor(secs / 60), secs % 60)
end

function net_header()
  if Game.time_remaining then
    return format_time(Game.time_remaining)
  end
  if Game.kill_limit then
    local max_kills = 0
    for i = 1,#Game.players do
      max_kills = math.max(max_kills, Game.players[i - 1].kills)
    end
    return string.format("%d", Game.kill_limit - max_kills)
  end
  return nil
end

function ranking_text(gametype, ranking)
  if (gametype == "kill monsters") or
     (gametype == "capture the flag") or
     (gametype == "rugby") or
     (gametype == "most points") then
    return string.format("%d", ranking)
  end
  if (gametype == "least points") then
    return string.format("%d", -ranking)
  end
  if (gametype == "cooperative play") then
    return string.format("%d%%", ranking)
  end
  if (gametype == "most time") or
     (gametype == "least time") or
     (gametype == "king of the hill") or
     (gametype == "kill the man with the ball") or
     (gametype == "defense") or
     (gametype == "tag") then
    return format_time(math.abs(ranking))
  end
  
  -- unknown
  return nil
end

function comp_player(a, b)
  if a.ranking > b.ranking then
    return true
  end
  if a.ranking < b.ranking then
    return false
  end
  if a.name < b.name then
    return true
  end
  return false
end

function sorted_players()
  local tbl = {}
  for i = 1,#Game.players do
    table.insert(tbl, Game.players[i - 1])
  end
  table.sort(tbl, comp_player)
  return tbl
end
